;; a very hack-'n'-slash way to forward HTML email in gnus
(defun jordan/html-forward ()
  (interactive)
  (require 'htmlize)
  (unless (member major-mode '(gnus-summary-mode gnus-article-mode))
    (user-error "Not in a Gnus buffer"))
  (let (forward-header p1)
    (gnus-summary-mail-forward)
    (goto-char (point-min))
    (replace-regexp "^<#mml.*>"
		    "<#multipart type=alternative>\n<#part type=text/plain>")
    (insert "<#part type=text/plain charset=\"utf-8\" disposition=inline nofile=yes>")
    (next-line)
    (move-beginning-of-line nil)
    (setq p1 (point))
    (search-forward-regexp "^<#multipart.*>")
    (setq forward-header (buffer-substring p1 (1- (match-beginning 0))))
    (move-beginning-of-line nil)
    (replace-regexp "^<#multipart.*>" "")
    (replace-regexp "^<#part type=text/plain.*>" "")
    (replace-regexp "<#part type=text/html.*>"
		    "<#multipart type=related><#part type=text/html>")
    (next-line)
    (move-beginning-of-line nil)
    (newline)
    (previous-line)
    (insert (concat "<pre>" (htmlize-string-to-html forward-header)
		    "</pre>"))
    (newline)
    (goto-char (point-max))
    (replace-string "<#/mml>" "<#/multipart>" nil nil nil t)
    (end-of-line)
    (delete-region (point) (point-max))
    (goto-char (point-min))
    (when (save-excursion
	    (goto-char (point-min))
	    (search-forward "" nil t))
      (replace-string "" ""))
    (goto-char (point-min))
    (message-goto-to)))
